
import javax.swing.*;  // load visual swing classes
import java.awt.*;     // load layout classes
import java.awt.event.*;  // load event handling classes
import java.text.*;

import org.nfunk.jep.*;
import org.nfunk.jep.type.*;

public class Falses
       extends JApplet  // inherits properties of JFrame class
       implements ActionListener{  // implements event handling
  
  private JEP myParser;

  private JButton startButton, space;  // button objects
  private JTextField point0, point1, tTolerance, nIteration, exprField;
  private JTextArea solution;
  private double q, q0, q1, p0, p1, c, p, fp, TOL;
  private int I, iterations;
  private boolean OK;
  private NumberFormat formatter;
  private double xValue;


  public void init() {
    myParser = new JEP();
    myParser.initFunTab(); // clear the contents of the function table
    myParser.addStandardFunctions();
    myParser.setTraverse(true);

   setVisualComponent();    
   
 }

  public void actionPerformed(ActionEvent e) {


    if (e.getSource() == startButton) {

      try {
                 p0 = Double.parseDouble(point0.getText());
                 p1 = Double.parseDouble(point1.getText());
                TOL = Double.parseDouble(tTolerance.getText());
         iterations = Integer.parseInt(nIteration.getText());
                OK  = true; 
            solution.setText("");             
            inputCheck();
        if(OK){ I= 2; 
              q0 = functnF(p0);
              q1 = functnF(p1);
              solution.append("  "+"I\tPn\tF(Pn) \n");  
              solution.append("======================================\n");
                 
       while(I<=iterations && OK){
               
               p = p1 - q1*(p1 - p0)/(q1 - q0);
               q = functnF(p);

               solution.append(" "+ I  +"\t"+ formatter.format(p) +"\t"+formatter.format(q)+"\n");       
            if (absVal(p - p1)< TOL)
               {
                solution.append("No of Iterations "+I+" \n");
                solution.append("Approximation solution P = "+formatter.format(p)+" \n");
                solution.append("with F(P) = "+formatter.format(q)+" \n");
                solution.append("Tolerance "+ TOL);

                OK = false;}
            else{
                  I++; 
                  if ( q*q1 < 0){ p0 = p1; q0 = q1;}
                  p1 = p; q1 = q;
                   
                 }

           }
        if (OK){
          solution.append("No of Iterations "+nIteration.getText()+" \n");
          solution.append("gave approximation P = "+formatter.format(p)+" \n");
          solution.append("with F(P) = "+formatter.format(q)+" \n");
          solution.append("not within tolerance "+ TOL);}
          }
       }
      catch (NumberFormatException ex)
        {
        solution.append("Error");
        }
      }
    }
   public void parseExpression() {
		myParser.initSymTab(); // clear the contents of the symbol table
		myParser.addStandardConstants();
		myParser.addVariable("x", xValue);
                myParser.setImplicitMul(true);
		myParser.parseExpression(exprField.getText());
	}


  public double functnF(double point)
   {
    double f;
    xValue = point;  
    parseExpression();
    f = myParser.getValue();  // example   f = (x + 4.0)*x^2 - 10.0;
    return f;
   }
  
  public boolean inputCheck()
   {
        String errorInfo;
        double pq;
        if( p0 > p1){pq = p0; p0 = p1; p1 = pq;}
          if ( p0 == p1){
            solution.append("P0 cannot equal P1 \n");  
            OK = false;}else{q0 = functnF(p0); q1=functnF(p1);
                              if(q0*q1>0){solution.append("F(P0) and F(P1) have same sign");
                                 OK = false;} }
          if (TOL <= 0.0){
            solution.append("Tolerance must be positive \n");
            OK = false;}
          if (iterations <= 0 ){
            solution.append("Number of Iterations must be positive Integer\n");
            OK = false;}
            parseExpression();
          if ((errorInfo = myParser.getErrorInfo()) != null){
            solution.append(errorInfo);
            OK =false;}
          return OK;
   }     

 public double absVal(double val)
  { 
    if( val >= 0) return val;
    else return -val;
  }  
 
   public void setVisualComponent()
    {
    startButton = new JButton("Start");
    point0 = new JTextField(4);
    point1 = new JTextField(4);
    tTolerance = new JTextField(6);
    nIteration = new JTextField(2);
    exprField = new JTextField("cos(x) - x");
    solution = new JTextArea(17,40);
    JScrollPane scrollPane = new JScrollPane(solution);   
    startButton.addActionListener(this);

    
    JPanel inputPanel1 = new JPanel(new GridLayout(3,3));

    inputPanel1.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel1.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel1.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel1.add(new JLabel("Function f(x) =:", JLabel.RIGHT));
    inputPanel1.add(exprField); 
    inputPanel1.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel1.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel1.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel1.add(new JLabel("           ", JLabel.RIGHT));

    JPanel inputPanel2 = new JPanel(new GridLayout(3,6));

    inputPanel2.add(new JLabel("Point P0:", JLabel.RIGHT));
    inputPanel2.add(point0);
    inputPanel2.add(new JLabel("Point P1:", JLabel.RIGHT));
    inputPanel2.add(point1);
    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));

    inputPanel2.add(new JLabel("TOL:", JLabel.RIGHT));
    inputPanel2.add(tTolerance);
    inputPanel2.add(new JLabel("No Iterations:", JLabel.RIGHT));
    inputPanel2.add(nIteration);
    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));

    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));
    inputPanel2.add(new JLabel("           ", JLabel.RIGHT));


    JPanel buttonPanel = new JPanel(new GridLayout(1,6));
    buttonPanel.add(startButton);
    buttonPanel.add(new JLabel("           ", JLabel.RIGHT));    
    buttonPanel.add(new JLabel("           ", JLabel.RIGHT));    
    buttonPanel.add(new JLabel("           ", JLabel.RIGHT));    
    buttonPanel.add(new JLabel("           ", JLabel.RIGHT));    
    buttonPanel.add(new JLabel("           ", JLabel.RIGHT));    

    JPanel inputAreaPanel = new JPanel(new BorderLayout());
    inputAreaPanel.add(inputPanel1, "North");
    inputAreaPanel.add(inputPanel2, "South");

    JPanel mainPanel = new JPanel(new BorderLayout());
    mainPanel.add(inputAreaPanel, "North");
    mainPanel.add(scrollPane, "Center");
    mainPanel.add(buttonPanel, "South");

    getContentPane().add(mainPanel);
    
    formatter = NumberFormat.getNumberInstance();
    formatter.setMaximumFractionDigits(9);
    formatter.setMinimumFractionDigits(9);

      }


  }
    
   
