function [res] = F(I,M,V,s)
% This function is used by Runge-Kutta order 4 method
% (Algorithm 5.7) to define the functions on the right
% hand side in the differential equations.
if M == 2
   g = inline(s(I),'t','y1','y2');
   res = g(V(1),V(2),V(3));
elseif M == 3
   g = inline(s(I),'t','y1','y2','y3');
   res = g(V(1),V(2),V(3),V(4));
elseif M == 4
   g = inline(s(I),'t','y1','y2','y3','y4');
   res = g(V(1),V(2),V(3),V(4),V(5));
elseif M == 5
   g = inline(s(I),'t','y1','y2','y3','y4','y5');
   res = g(V(1),V(2),V(3),V(4),V(5),V(6));
elseif M == 6
   g = inline(s(I),'t','y1','y2','y3','y4','y5','y6');
   res = g(V(1),V(2),V(3),V(4),V(5),V(6),V(7));
else
   g = inline(s(I),'t','y1','y2','y3','y4','y5','y6','y7');
   res = g(V(1),V(2),V(3),V(4),V(5),V(6),V(7),V(8));
end;




