 function [res] = QQ(L,XX,YY,DELTA,J1,J2,J3,I1,I2,A,B,C)
% This function is used by Finite Element Method
% (Algorithm 12.5) to perform integration
% over triangles.
 syms('X', 'Y', 'I','T1', 'T2', 'T3', 'QQQ','S');
 S = zeros(1,7);
 X = zeros(1,7);
 Y = zeros(1,7);
 X(1) = XX(J1);
 Y(1) = YY(J1);
 X(2) = XX(J2);
 Y(2) = YY(J2);
 X(3) = XX(J3);
 Y(3) = YY(J3);
 X(4) = 0.5*(X(1)+X(2));
 Y(4) = 0.5*(Y(1)+Y(2));
 X(5) = 0.5*(X(1)+X(3));
 Y(5) = 0.5*(Y(1)+Y(3));
 X(6) = 0.5*(X(2)+X(3));
 Y(6) = 0.5*(Y(2)+Y(3));
 X(7) = (X(1)+X(2)+X(3))/3.0;
 Y(7) = (Y(1)+Y(2)+Y(3))/3.0;
 if L == 1
 for I = 1 : 7
 S(I) = P(X(I),Y(I));
 end;
 end;
 if L == 2
 for I = 1 : 7
 S(I) = Q(X(I),Y(I));
 end;
 end;
 if L == 3
 for I = 1 : 7
 S(I) = RR(X(I),Y(I),A,B,C,I,I1,I2);
 end;
 end;
 if L == 4
 for I = 1 : 7
 S(I) = FFF(X(I),Y(I),A,B,C,I,I1);
 end;
 end;
 T1 = 0;
 for I = 1 : 3
 T1 = T1+S(I);
 end;
 T2 = 0;
 for I = 4 : 6
 T2 = T2+S(I);
 end;
 T3 = S(6);
 QQQ = 0.5*(T1/20+2*T2/15+9*T3/20)*abs(DELTA);
 res = QQQ;
